REM ***************************************
REM *                                     *
REM *            "HiVGA.INC"              *
REM *       Fr HiVGA Version 1.75        *
REM *  (c) 1994-96 by DELIAMBER-Software  *
REM *           Matthus Stadler          *
REM *                                     *
REM *  Unregistrierte Shareware-Version   *
REM *      fr PowerBasic (TM) 3.x        *
REM *                                     *
REM ***************************************

REM **********************************************************************
REM "HiVGA" ist Shareware ohne irgendwelche Funktionseinschrnkungen,
REM d.h. Sie knnen das Produkt vollstndig testen, bevor Sie sich zum
REM Kauf der Vollversion entschlieen. Die Shareware-Version unter-
REM scheidet sich von der Vollversion lediglich dadurch, da bei der
REM Initialisierung der Toolbox eine Shareware-Meldung erscheint,
REM ausserdem erhalten unregistrierte Anwender keinen Support.

REM Die Vollversion erhalten Sie fr 40.00 DM (Bankberweisung oder
REM Verrechnungsscheck). Lieferung auf 3 1/2 Zoll Diskette.


REM Bestellungen richten Sie bitte an:

REM    Matthus Stadler
REM    Schtzenstr. 37
REM    D-76137 Karlsruhe


REM Bankberweisung auf Konto:

REM    2583 45-759
REM    Postgiroamt Karlsruhe
REM    Bankleitzahl 66010075


REM Der Autor ist erreichbar via EMAIL:
REM InterNet: matthaeus_stadler@p1.music-bbs.schiele-ct.de
REM FidoNet:  Matthaeus Stadler at 2:2476/401.1
REM **********************************************************************

$LIB GRAPH OFF  'solange nur mit HiVGA gearbeitet wird, knnen die Power
		'Basic Grafik-Routinen wegelassen werden, um den Code zu
		'verkleinern.

$STACK 5120     'Stack vergrssern fr lokale HiVGA Variablen (Stackgre
		'sollte -> mindestens <- 5120 betragen).

REM Vordefinierte Konstanten zur bergabe an VMODE
%ModeNo=255
%VGACode=254
%GetXRes=253
%GetYRes=252
%VidSEG=251
%ScanLine=250
%VGAType=249
%VGAMem=248
%BankSize=247
%Pages=246
%ColMode=245
%GetVer=244
%SVGACheck=241
%VESACheck=240
%VESAVer=238
%ClearSCR=237

REM Konstanten fr die Modi
REM Text
%T40x25=1
%T80x25=3

REM Standard VGA
%V320x200=13
%V320x200x4=14
%V320x400=15
%V360x480=16

REM SVGA 256-Farben-Modi
%S640x400=17
%S640x480=18
%S800x600=19
%S1024x768=20
%S1280x1024=21
%S1600x1200=22
%UsrMode=22

REM SVGA HiColor-Modi (32767-Farben)
%H320x200=23
%H640x400=25
%H640x480=27
%H800x600=29
%H1024x768=31
%H1280x1024=33

REM SVGA RealColor-Modi (65535-Farben)
%R320x200=24
%R640x400=26
%R640x480=28
%R800x600=30
%R1024x768=32
%R1280x1024=34

REM weitere Konstanten
%TRUE=1
%FALSE=0
%Font8x8=1
%Font8x14=2
%Font8x16=3
%Font8x8MC=-1
%Font8x14MC=-2
%Font8x16MC=-3

REM Rckgaben von VMode
%ModeOk=0
%NoVGA=-1
%FalseMode=1
%OnlyTTL=2
%NotSupported=3
%NotKnown=4
%Standard=0
%Planar=1
%HiCol=2
%RealCol=3

REM Nach der Compileranweisung $LINK mu der Pfad zum Link-File
REM angegeben werden!

$IF %PB30  '%PB30=%TRUE fr PB 3.1/3.2 oder %PB30=%FALSE fr PB 3.0 setzen!
  $LINK"HIVGA30.PBL" 'fr PowerBasic Version 3.0
$ELSE
  $LINK"HIVGA3X.PBL" 'fr PowerBasic ab Version 3.1 (erzeugt kleinere EXEs)
$ENDIF

REM FUNCTIONS
DECLARE FUNCTION GetCPU%()
DECLARE FUNCTION SavePCX%(FileName$, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE FUNCTION LoadPCX%(FileName$, BYVAL XPos%, BYVAL YPos%)
DECLARE FUNCTION SaveHVS%(FileName$, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE FUNCTION LoadHVS%(FileName$, BYVAL XPos%, BYVAL YPos%, BYVAL PAL%)
DECLARE FUNCTION SaveTGA%(FileName$, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE FUNCTION LoadTGA%(FileName$, BYVAL XPos%, BYVAL YPos%)
DECLARE FUNCTION VMode%(BYVAL Mode%)
DECLARE FUNCTION GetSize???(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE FUNCTION GetPix??(BYVAL X%, BYVAL Y%)

REM PROCEDURES
DECLARE SUB SetPix(BYVAL X%, BYVAL Y%, BYVAL Col??)
DECLARE SUB XYLine(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL Col??)
DECLARE SUB LineTo(BYVAL X%, BYVAL Y%, BYVAL Col??)
DECLARE SUB MoveTo(BYVAL X%, BYVAL Y%)
DECLARE SUB Fill(BYVAL X%, BYVAL Y%, BYVAL Col??, BYVAL Border??)
DECLARE SUB Scale(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL xFac%, BYVAL yFac%)
DECLARE SUB Bar(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL Col??)
DECLARE SUB Box(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL Col??)
DECLARE SUB TxtStyle(BYVAL Font%, BYVAL CWide%, BYVAL CHigh%, BYVAL CDist%)
DECLARE SUB SetPage(BYVAL Page%)
DECLARE SUB ShowPage(BYVAL Page%)
DECLARE SUB CopyPage(BYVAL FromPage%, BYVAL ToPage%)
DECLARE SUB CLG(BYVAL Col??)
DECLARE SUB XSpeed(BYVAL Switch%)
DECLARE SUB GetImg(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, ADR?)
DECLARE SUB SetImg(BYVAL X%, BYVAL Y%, ADR?)
DECLARE SUB GetSprite(BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, ADR?)
DECLARE SUB SetSprite(BYVAL HideCol??, BYVAL X%, BYVAL Y%, ADR?)
DECLARE SUB MoveSprite(BYVAL HideCol??, BYVAL FromX%, BYVAL FromY%, BYVAL ToX%, BYVAL ToY%, SPR?, Back?)
DECLARE SUB PixPan(BYVAL P%)
DECLARE SUB GScroll(BYVAL X%, BYVAL Y%)
DECLARE SUB SplitScr(BYVAL SplitAt%)
DECLARE SUB ScrOnOff(BYVAL Switch%)
DECLARE SUB Fade(BYVAL Brightness%, BYVAL FirstCol%, BYVAL LastCol%)
DECLARE SUB MakeCol(BYVAL ColNo%, BYVAL Red%, BYVAL Green%, BYVAL Blue%)
DECLARE SUB ReadCol(BYVAL ColNo%, Red%, Green%, Blue%)
DECLARE SUB SetGrey(BYVAL FirstCol%, BYVAL TotalCol%)
DECLARE SUB GetCol()
DECLARE SUB SetCol(BYVAL FirstCol%, BYVAL LastCol%)
DECLARE SUB CycleCol(BYVAL FirstCol%, BYVAL LastCol%, BYVAL Direction%)
DECLARE SUB SCircle(BYVAL X%, BYVAL Y%, BYVAL R%, BYVAL Col??)
DECLARE SUB FCircle(BYVAL X%, BYVAL Y%, BYVAL R%, BYVAL Col??)
DECLARE SUB SEllipse(BYVAL X%, BYVAL Y%, BYVAL A%, BYVAL B%, BYVAL Col??)
DECLARE SUB FEllipse(BYVAL X%, BYVAL Y%, BYVAL A%, BYVAL B%, BYVAL Col??)
DECLARE SUB WScroll(BYVAL D%, BYVAL L%, BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%, BYVAL Col%)
DECLARE SUB WriteTxt(BYVAL X%, BYVAL Y%, BYVAL Col??, TXT$, BYVAL BIOS%)
DECLARE SUB PlotTxt(BYVAL X%, BYVAL Y%, BYVAL Col??, TXT$)
DECLARE SUB CopyBank(BYVAL Source%, BYVAL Goal%)
DECLARE SUB InstUsrMode(BYVAL Code%, Byval XMax%, BYVAL YMax%)
DECLARE SUB DHSize()
DECLARE SUB SplitPixPan()
DECLARE SUB WVRetrace()
DECLARE SUB WDisplay()
DECLARE SUB GetPal()
DECLARE SUB SetPal()
DECLARE SUB RestorePal()
DECLARE SUB InitHiVGA()

REM MOUSE_SUPPORT
DECLARE FUNCTION InitMouse%(BYVAL Methode%)
DECLARE FUNCTION InstMouseCur%(ADR?)
DECLARE SUB MouseStat(Button%, Xpos%, Ypos%)
DECLARE SUB MoveMouse(BYVAL Xpos%, BYVAL Ypos%)
DECLARE SUB MouseBorderX(BYVAL Xmin%, BYVAL Xmax%)
DECLARE SUB MouseBorderY(BYVAL Ymin%, BYVAL Ymax%)
DECLARE SUB SetHotSpot(BYVAL SpotX%, BYVAL SpotY%)
DECLARE SUB SetSMCur()
DECLARE SUB HideMouse()
DECLARE SUB ShowMouse()

Let Old_Date$ = Date$
Date$ = "01-01-1996"
CALL InitHiVGA 'ZUM INITIALISIEREN VON HIVGA!!!
Date$ = Old_Date$